> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Add a new Golden Config tree

POST https://example.itential.io/configuration_manager/configs
Content-Type: application/json

Adds a new Golden Config tree.

Reference: https://docs.itential.com/itential-cloud/api-reference/configuration-manager/create-golden-config-tree

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Body (application/json)

This endpoint expects an object.

- `name` (string, optional)
- `deviceType` (string, optional)
- `description` (string, optional)

## Response

### 200

details of the initial version of the newly created tree

- `id` (string, optional)
- `name` (string, optional)
- `description` (string, optional)
- `deviceType` (string, optional)
- `version` (string, optional)
- `root` (object, optional)
  - `name` (string, required)
  - `attributes` (object, required)
    - `devices` (list of string, optional)
    - `configId` (string, optional)
  - `children` (list of any, required)
- `variables` (list of object, optional)
  - `name` (string, optional)
  - `type` (enum, optional)
    - Allowed values: `literal`, `regex`
  - `value` (string, optional)
- `created` (string, optional)
- `createdBy` (string, optional)
- `lastUpdated` (string, optional)
- `lastUpdatedBy` (string, optional)

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "id": "5c35355dbebaa82eaf8113f0",
  "name": "Cisco Edge - Day 0",
  "description": "string",
  "deviceType": "cisco-ios",
  "version": "initial",
  "root": {
    "name": "base",
    "attributes": {
      "devices": [
        "xr9kv-atl"
      ],
      "configId": "5c35355dbebaa82eaf8113f0"
    },
    "children": [
      null
    ]
  },
  "variables": [
    {
      "name": "variable name",
      "type": "literal",
      "value": "variable value"
    }
  ],
  "created": "2019-04-12T14:42:47.958Z",
  "createdBy": "5c35355dbebaa82eaf8113f0",
  "lastUpdated": "2019-04-12T14:42:47.958Z",
  "lastUpdatedBy": "5c35355dbebaa82eaf8113f0"
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/configuration_manager/configs"

payload = {}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/configuration_manager/configs';
const options = {method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{}'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/configuration_manager/configs"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/configuration_manager/configs")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://example.itential.io/configuration_manager/configs")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://example.itential.io/configuration_manager/configs', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/configuration_manager/configs");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/configuration_manager/configs")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```